'use strict';

const fileHelper = require('./../fileHepler');
const basePath = require('./../path');
const storeDirectory = basePath.storeDirectory;
let template = require('art-template');
const utils = require('./../lib/utils');
let {
  beautifyFile,
  dateToTime
} = utils;

const init= (urls)=>{
  return new Promise((resolve,reject)=>{

    let tempPath = `${storeDirectory}/types.js`;
    let html = template(basePath.buildTemplateDirectory + '/coder/types.txt', {
      urls: urls,
      time: dateToTime(Math.floor(new Date().getTime() / 1000))
    });
    fileHelper.writeFile(tempPath, beautifyFile(html))
      .then(res=>{
        resolve()
      })
      .catch(res=>{
        reject()
      })
  })
};

module.exports = init;








