'use strict';

const fileHelper = require('./../fileHepler');
const basePath = require('./../path');
const apiUrlDirectory = basePath.apiUrlDirectory;
let template = require('./../lib/template');
const utils = require('./../lib/utils');
let {
  beautifyFile,
  dateToTime
} = utils;

const gitIgnore = require('./../lib/gitignore');

let apiUrlPromise = [];
const init= (urls)=>{


  return new Promise((resolve,reject)=>{
    let fileNames = [];
    urls.map(item => {
      let type = process.env.type;
      let service = process.env.service;
      let reg = /^.+(\.dome)$/;
      //打包正式，去掉dome模块
      if(type === 'build' && service === 'build' && reg.test(item.filePathName)) {
        fileNames.push(item.fileName);
        return
      }
      //打包非正式
      let tempPath = `${apiUrlDirectory}/modules/${item.fileName}`;
      let html = template(basePath.buildTemplateDirectory + '/coder/apiurl.txt', {
        urls: item.value,
        title: item.title,
        time: dateToTime(Math.floor(new Date().getTime() / 1000)),
        model: `modules/${item.fileName}`,
      });
      html = beautifyFile(html);
      apiUrlPromise.push(fileHelper.writeFile(tempPath, html))
      fileNames.push(item.fileName);
    });

    //设置git忽略文件
    apiUrlPromise.push(gitIgnore(fileNames, apiUrlDirectory + '/modules'));

    Promise.all(apiUrlPromise)
      .then(res => {
        resolve()
      })
      .catch(res=>{
        reject(res)
      })
  })
};

module.exports = init;








