'use strict';

const fileHelper = require('./../fileHepler');
const basePath = require('./../path');
const clog = require('./../clog');
const utils = require('./../lib/utils');
const {os} = require('./../lib/nodeSystem');
const template = require('./../lib/template');

const init = ()=>{
  let argv = utils.getArgv();
  if (argv.length === 0) {
    clog(`请传入参数，例如： npm run form.create dome ${os.EOL}1、params1: 插件名称;${os.EOL}`, 'red');
    process.exit(0);
  }
  clog('开始创建自定义插件', 'cyanBG');
  utils.logsLine(clog, 'start');
  let templatePath = basePath.buildDir + '/form/template/template.vue';
  let packName = utils.strToArray(argv[0]);
  let data = {
    fileName: `Xd${utils.strToArray(packName, 4)}`,
    cssName:  `xd-${packName.join('-')}`
  };
  let vue = template(templatePath, data);
  let formItemPath = basePath.srcDirectory + `/components/formItem/${data.fileName}.vue`;
  if(fileHelper.existFileSync(formItemPath)) {
    clog(`文件路径已存在，路径: ${os.EOL} ${fileHelper.getPlatformSurePath(formItemPath)}`, 'red');
    process.exit(0);
  }
  fileHelper.writeFileSync(formItemPath, vue);
  clog(`创建自定义插件成功，路径：`, 'green');
  clog(`${fileHelper.getPlatformSurePath(formItemPath)}`, 'cyan');
  utils.logsLine(clog);
};

init();
