'use strict';
let __json = null;
const clog = require('./../clog');
const utils = require('./../lib/utils');
const fileHelper = require('./../fileHepler');

class Json {
  constructor(){
    this.base = 'https://image.jufubao.cn/jfb_version/'
  }

  getByCodeJson(code){
    return new Promise((resolve, reject)=>{
      let url = this.base + code + '.json';
      fileHelper.get(url).then(res => {
        resolve(res);
      }).catch(error => {
        resolve('fail');
        clog(`${JSON.stringify(error)}`, 'red');
        process.exit(-1)
      })
    })
  }

}

const init = () =>{
  if (__json !== null) return __json;
  return __json = new Json();
};

module.exports = init();
