'use strict';

const fileHelper = require('./../build/fileHepler');
const basePath = require('./../build/path');
const clog = require('./../build/clog');
const os = require('os');


let SRC_ROOT_PATH = ''
let configPath = `${basePath.rootDir}/gulp.config.js`;
let modelData = [];
let name = []

//检查配置文件是否存在
if(!fileHelper.existFileSync(configPath)) {
  modelData = [];
  SRC_ROOT_PATH = basePath.rootDir + '/node_modules/jufubao-admin-library/library/'
}
else{
  let config = require(configPath);

  //非打包模式
  if(config.src && fileHelper.existFileSync(config.src)) SRC_ROOT_PATH = config.src;
  else {
    SRC_ROOT_PATH = basePath.rootDir + '/node_modules/jufubao-admin-library/library/'
  }

  //打包模式
  if(process.env.type === 'build') {
    SRC_ROOT_PATH = basePath.rootDir + '/node_modules/jufubao-admin-library/library/'
  }

  modelData = config.schemas.filter(item=>{
    return item.STATUS
  }).map(item=>{
    name.push(item.DEST_PAGE_PATH)
    return {
      NAME:  item.NAME,
      API_APP: item.API_APP,  // 项目API目录 /${API_APP}/v1/supplier-stat/total-counts
      SRC_ROOT_PATH: fileHelper.getPlatformSurePath(`${SRC_ROOT_PATH}/${item.PACK_MODULE_DIR}`),
      DEST_PAGE_PATH: item.DEST_PAGE_PATH,  // 项目页面目录
      DEST_ROOT_PATH: "src",  // 项目根目录
      replaceOptionServer: item.replaceOptionServer, // 替换选项卡 fn: server
      ROUTE_TO_CHILDREN:item.ROUTE_TO_CHILDREN || false,
    }
  })

}

if(modelData.length >0 ) {
  clog(`已安装模块：${os.EOL}【${name.join('】【')}】${os.EOL}`, 'green')
}

module.exports = [{libPath:SRC_ROOT_PATH}].concat(modelData);
